%% Day 3 HW solutions for Learning Catalytics questions
% Written by BB 2018/08/07
clear
close all

%% Problem 1

% How many inputs does this function have?
% 
%   function [x,y,z] = namefunction(a,b,c,d)
%
% This function has 4 inputs: a,b,c,d

%% Problem 2

% How many outputs does this function have?
% 
%   function [x,y,z] = namefunction(a,b,c,d)
%
% This function has 3 outputs: x,y,z


%% Problem 3

% What word would you type to have MATLAB execute this function?
% 
%   function [x,y,z] = namefunction(a,b,c,d)
%
% To run the function, you would type 'namefunction' to the Command Window
% This assumes that the file with this function is named 'namefunction.m'
% The file itself could have a typo in the function definition at the top
% of the file. All that matters is the file name


%% Problem 4
 
% The function used for this problem is in a separate file
% 'myRandInt.m'. This problem could be done easily with the built-in
% function randi, e.g.
%
%    randi([x y],1,z)
%
% But our solution uses ceil and rand.


% We can make sure the distribution is uniform by generating a large number
% of inputs and making histograms for a few different ranges

ranges = [ 1  15; ...
           4  22; ...
          63  56; ...
         -10  10 ];

figure;
for iRange = 1:size(ranges,1)
    
    %Generate the random integers
    randInts = ranZ(ranges(iRange,1),ranges(iRange,2),1e5);
    
    % Get the bins of the histogram
    sortedRange = sort(ranges(iRange,:),'ascend');
    binCenters = sortedRange(1):sortedRange(end);
    
    % Make the subplot
    subplot(size(ranges,1),1,iRange)
    hist(randInts,binCenters);
    set(gca,'XTick',binCenters')
    xlim(sortedRange+[-1 1])
    title(sprintf('Histogram of random numbers from %d to %d',sortedRange))
end

% Do these distributions look uniform to you? Try this test code out with
% your own function!

%% Problem 5 - 19

% For problems 5 - 19, see the 'AneuploidSolution.m' file. It
% contains a detailed walkthrough. Make sure the data file 
% is in the same directory